#pragma semicolon 1
#include <sourcemod>
#define PLUGIN_VERSION "1.1"

new Handle:default_map		= INVALID_HANDLE;
new Handle:NoPlayers		= INVALID_HANDLE;
new Handle:no_players_time	= INVALID_HANDLE;

public Plugin:myinfo = 
{
	name	= "Auto-Changes Maps",
	author	= "JumPixX",
	version = PLUGIN_VERSION,
	url		= "http://jumpixx.ru/"
};

public OnPluginStart()
{
	default_map 	= CreateConVar("acm_maps",	"de_dust2", "Initial map of server");
	no_players_time = CreateConVar("acm_time",	"300", 	 	"How many seconds before the map changes", _, true, 0.0);

	HookEvent("player_disconnect",	player_disconnect);
	HookEvent("player_connect",		player_connect);
}

public player_disconnect(Handle:event, const String:name[], bool:silent)
{
	new PlayerCount = GetClientCount(false);
	new Float:sec 	= GetConVarFloat(no_players_time);
	if (--PlayerCount < 1)
	{
		PrintToServer("[ACM] On server no more players, timer is started!");
		NoPlayers = CreateTimer(sec, ChangeMaps);
	}
}

public player_connect(Handle:event, const String:name[], bool:silent)
{
	if (NoPlayers != INVALID_HANDLE)
	{
		PrintToServer("[ACM] The timer is stopped!");
		KillTimer(NoPlayers);
		NoPlayers = INVALID_HANDLE;
	}
}

public Action:ChangeMaps(Handle:timer)
{
	decl String:StartMaps[PLATFORM_MAX_PATH];
	decl String:ServerMap[PLATFORM_MAX_PATH];
	GetCurrentMap(ServerMap, sizeof(ServerMap));
	GetConVarString(default_map, StartMaps, sizeof(StartMaps));
	if (!StrEqual(StartMaps, ServerMap))
	{
		ForceChangeLevel(StartMaps, "No players on server");
	}
	NoPlayers = INVALID_HANDLE;
}